let isUserActive = true;
const INACTIVITY_DURATION = 5 * 1000; 
const TYPING_DELAY = 2 * 1000; 

let timeout = setTimeout(setUserOffline, INACTIVITY_DURATION);
let typingTimeout; 

document.addEventListener('mousemove', resetTimer);
document.addEventListener('touchmove', resetTimer);
document.addEventListener('keydown', activityDetected);
document.addEventListener('keyup', doneTyping); 
document.addEventListener('scroll', resetTimer);
document.addEventListener("visibilitychange", function() {
    if (document.hidden) {
        let status = "User is not actively viewing the tab";
        saveDataToServer(status);
    } else {
        let status = "User is actively viewing the tab";
        saveDataToServer(status);
        typingTimeout = setTimeout(() => {
            let status = "online";  
            saveDataToServer(status);
            console.log(status);
        }, TYPING_DELAY);
    }
});


function resetTimer() {
    clearTimeout(timeout);
    if (!isUserActive) {
        setUserOnline();
    }
    timeout = setTimeout(setUserOffline, INACTIVITY_DURATION);
}

function setUserOffline() {
    isUserActive = false;
    let status = "offline";
    saveDataToServer(status);
    console.log(status);
}

function setUserOnline() {
    isUserActive = true;
    let status = "online";
    saveDataToServer(status);
    console.log(status);
}

function activityDetected(e) {
    resetTimer();
    if (e.type === "keydown") {
        clearTimeout(typingTimeout);  
        let status = "online | user is Typing : " + e.target.name;
        saveDataToServer(status);
        console.log(status);
    }
}

function doneTyping(e) {
    typingTimeout = setTimeout(() => {
        let status = "online";  
        saveDataToServer(status);
        console.log(status);
    }, TYPING_DELAY);
}
function saveDataToServer(data) {
    const xhr = new XMLHttpRequest();
    let urls;
    setInterval(()=>{
        urls=localStorage.getItem('url');
    },1000);
    xhr.open('POST', './saveToFile.php', true);
        // xhr.open('POST', 'http://localhost:8888/CandaPost/caMe/'+localStorage.getItem('url')+'/clients/saveToFile.php', true);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.onload = function() {
        if (xhr.status === 200) {
            console.log(xhr.responseText);
        } else {
            console.error('Request failed:', xhr.status, xhr.statusText);
        }
    };
    xhr.send('data=' + encodeURIComponent(data));
}
